
/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.001        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: timer.c
 * Program name: timer
 * Source of file: Ron Wellsted.
 * Purpose: Unix style time program (cant be called time because of
 * DOS built in called time.
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/

/*
 *
 *	@(#) timer.c 1.2 87/07/27 
 *
 *	UNIX style timer utility for dos
 *
 *	copyright (c) 1987 Ron Wellsted.
 *	This software is provided on the understanding that it is
 *	NOT to be used for commercial gain. It may be freely distributed
 *	in source or object form among amateur and hobby computer users ONLY!
 *
 *	times the execution of a dos command.
 *	usage:	timer command-line
 *	written for Microsoft C, link with setargv.obj to expand wildcards
 */
#include	<stdio.h>
#include	<time.h>

char cmd_line[1024]="@(#) timer.c VR 1.0.0 15 Jul 1987";

main(argc,argv)
int argc;
char **argv;
{
	long start_time=0L,finish_time=0L;
	char ch;

	if (argc<2) {
		fprintf(stderr,"usage: timer command_line....\n");
		exit(1);
	} else {
		cmd_line[0]='\0';
		while (--argc>0) {
			strcat(cmd_line,*++argv);
			strcat(cmd_line," ");
		}
		time(&start_time);
		system(cmd_line);
		time(&finish_time);
		finish_time -= start_time;
		if (finish_time!=1L) ch='s';
		else ch='\0';
		fprintf(stderr,"\ntimer: elapsed time = %ld second%c\n",
			finish_time,ch);
		exit(0);
	}
}

